#include <windows.h>
#include "CLocationDlg.h"
#include "resource.h"

#include "shlobj.h"		/* shell Լ ϱ Ͽ include */

/****************************************************************************
 **                                                                        **
 **               ##  CLocationDlg /Ҹ   ##                **
 **                                                                        **
 ****************************************************************************/

CLocationDlg::CLocationDlg()
{
	/*  &    ִ ü ʱȭ Ѵ. */
	ZeroMemory(&stPathInfo, sizeof(_PathInfo));
}

CLocationDlg::~CLocationDlg()
{

}

/****************************************************************************
 **                                                                        **
 **                      ##  ܺο Ǵ Լ ##                       **
 **                                                                        **
 ****************************************************************************/

void CLocationDlg::SetLocationInfo(_PathInfo &stInfo)
{
	/* ü   Ų. */
	memcpy((void *)&stPathInfo, (void *)&stInfo, sizeof(_PathInfo));
}

void CLocationDlg::GetLocationInfo(_PathInfo &stInfo)
{
	/* ü   Ų. */
	memcpy((void *)&stInfo, (void *)&stPathInfo, sizeof(_PathInfo));
}

/****************************************************************************
 **                                                                        **
 **                 ##  ȭ ⺻ ޼ ó Լ  ##                 **
 **                                                                        **
 ****************************************************************************/

BOOL CLocationDlg::OnInitDialog(HWND hDlg)
{
	/* Build   ִ  ġ ʱȭ Ų. */
	SetDlgItemText(hDlg, IDC_TOOLS_EDIT, stPathInfo.szToolsPath);

	/* ۾  ġ ʱȭ Ų. */
	SetDlgItemText(hDlg, IDC_WORKING_EDIT, stPathInfo.szWorkingPath);

	/*  ġ ʱȭ Ų. */
	SetDlgItemText(hDlg, IDC_EDITOR_EDIT, stPathInfo.szEditorPath);

	/* ϰ  ! */
	return CChildDlg::OnInitDialog(hDlg);
}

BOOL CLocationDlg::OnCommand(HWND hWndCtl, int wNotifyCode, int wID)
{
	switch(wID)
	{

		/* Build   ִ   ư ó Լ */
	case IDC_TOOLS_BUTTON:
		OnToolsSelect();
		return TRUE;

		/* ۾   ư ó Լ */
	case IDC_WORKING_BUTTON:
		OnWorkingSelect();
		return TRUE;

		/* ͸ ϴ ư ó Լ */
	case IDC_EDITOR_BUTTON:
		OnEditorSelect();
		return TRUE;

		/* Ȯ ư ó Լ */
	case IDOK:
		OnOk();
		return TRUE;

	}

	return FALSE;
}

/****************************************************************************
 **                                                                        **
 **         ##  WM_COMMAND ޼ Ǵ ư ó Լ  ##            **
 **                                                                        **
 ****************************************************************************/

void CLocationDlg::OnToolsSelect()
{
	char szFolderName[MAX_PATH];
	BOOL bResult;

	/* ڷ   Է ޴´. */
	bResult = SelectFolder(szFolderName);

	/*  Է ޴    */
	if(!bResult)
		return;

	/*  и ǥø ԷѴ. */
	InsertFolderMark(szFolderName);

	/*  ̸߿  ִ ˻Ѵ. */
	bResult = BlankInFolderName(szFolderName);

	/*  ̸    Ѵ. */
	if(bResult) {
		MessageBox(hDlgMain, " ̸߿   ֽϴ.\n\n"
			" Compiler ν  մϴ.\n\n"
			"ٽ  ֽʽÿ.", " Builder", MB_OK | MB_ICONERROR);
		return;
	}

	/*    Ʈ Ѵ. */
	SetDlgItemText(hDlgMain, IDC_TOOLS_EDIT, szFolderName);
}

void CLocationDlg::OnWorkingSelect()
{
	char szFolderName[MAX_PATH];
	BOOL bResult;

	/* ڷ   Է ޴´. */
	bResult = SelectFolder(szFolderName);

	/*  Է ޴    */
	if(!bResult)
		return;

	/*  и ǥø ԷѴ. */
	InsertFolderMark(szFolderName);

	/*  ̸߿  ִ ˻Ѵ. */
	bResult = BlankInFolderName(szFolderName);

	/*  ̸    Ѵ. */
	if(bResult) {
		MessageBox(hDlgMain, " ̸߿   ֽϴ.\n\n"
			" Compiler ν  մϴ.\n\n"
			"ٽ  ֽʽÿ.", " Builder", MB_OK | MB_ICONERROR);
		return;
	}

	/*    Ʈ Ѵ. */
	SetDlgItemText(hDlgMain, IDC_WORKING_EDIT, szFolderName);
}

void CLocationDlg::OnEditorSelect()
{
	char lpstrFile[MAX_PATH] = "";
	OPENFILENAME OFN; /*    ȭ ü */

	memset(&OFN, 0, sizeof(OPENFILENAME));

	OFN.lStructSize		= sizeof(OPENFILENAME);		/*  Ȯ		*/
	OFN.hwndOwner		= hDlgMain;					/* θ  ڵ	*/
	OFN.lpstrFilter		= "Program (*.exe)\0*.exe\0";	/* 	*/
	OFN.lpstrFile		= lpstrFile;		/*   ̸(+path)    */
	OFN.lpstrFileTitle	= NULL;				/*  ̸  				*/
	OFN.nMaxFile		= MAX_PATH;			/* ִ  							*/

	if(GetOpenFileName(&OFN)) /*  о鿴 */ 
		/*  ڿ  ġ Ʈ Ѵ. */
		SetDlgItemText(hDlgMain, IDC_EDITOR_EDIT, lpstrFile); 
}

void CLocationDlg::OnOk()
{
	char szPath[MAX_PATH];

	/* Build   ִ  ġ  ´. */
	GetDlgItemText(hDlgMain, IDC_TOOLS_EDIT, szPath, MAX_PATH);

	/* ü Ѵ. */
	strcpy(stPathInfo.szToolsPath, szPath);

	/* ۾  ġ  ´. */
	GetDlgItemText(hDlgMain, IDC_WORKING_EDIT, szPath, MAX_PATH);

	/* ü Ѵ. */
	strcpy(stPathInfo.szWorkingPath, szPath);

	/*  ġ  ´. */
	GetDlgItemText(hDlgMain, IDC_EDITOR_EDIT, szPath, MAX_PATH);

	/* ü Ѵ. */
	strcpy(stPathInfo.szEditorPath, szPath);

	/* ȭڸ  Լ */
	EndDialog(hDlgMain, IDOK);		/* ShowDialogBox ϰ IDOK Ѵ. */
}

/****************************************************************************
 **                                                                        **
 **                     ##   ޼ ó Լ  ##                      **
 **                                                                        **
 ****************************************************************************/

BOOL CLocationDlg::SelectFolder(char *pFolderName)
{
	BROWSEINFO BrowseInfo;
	LPITEMIDLIST PIDL;
	LPMALLOC pMalloc;
	BOOL bResult;

	/*  Է  ǥϱ  ʱȭ */
	BrowseInfo.hwndOwner		= hDlgMain;
	BrowseInfo.pidlRoot			= NULL;
	BrowseInfo.pszDisplayName	= NULL;
	BrowseInfo.lpszTitle		= "  ּ.";
	BrowseInfo.ulFlags			= 0;
	BrowseInfo.lpfn				= NULL;
	BrowseInfo.lParam			= 0;

	/*  Է  ȭ鿡 ǥϰ ϰ	*/
	/*  ĺ PIDL ޴´.						*/
	PIDL = SHBrowseForFolder(&BrowseInfo);

	/* ڰ ''ư ٸ  Ѵ. */
	if(PIDL == NULL)
		return FALSE;

	/*  ĺڷκ   θ ´. */
	bResult = SHGetPathFromIDList(PIDL, pFolderName);

	/*   θ µ  ߻ϸ Ѵ.	*/
	if(!bResult)
		return FALSE;

	/*  ĺ PIDL    ũⰡ ̴.	*/
	/*  PIDL  ޸𸮸  ҴѴ. PIDL	*/
	/*   ȣڰ  ޸ Ҵ Ѵ.	*/
	/*															*/
	/* Shell IMalloc ̽ ͸ ´. 		*/
	/* ߻ϸ Ѵ.										*/
	if(SHGetMalloc(&pMalloc) != NOERROR)
		return FALSE;

	/* PIDL  Ҵ ޸𸮸 Ѵ. */
	pMalloc->Free(PIDL);

	/* IMalloc ̽   Ƿ ReleaseѴ.	*/
	pMalloc->Release();

	return TRUE;
}

BOOL CLocationDlg::InsertFolderMark(char *pFolderName)
{
	/* Ķ Է° null̸  */
	if(pFolderName == NULL)
		return FALSE;

	int iLength;

	/*  ̸ ̸ ޴´. */
	iLength = strlen(pFolderName);

	/*  ̸   и ǥð ִ ȮϿ	*/
	/*   ִ´.										*/
	if(*(pFolderName+iLength-1) != '\\') {
		*(pFolderName+iLength+0) = '\\';	/*  и ǥ Է	*/
		*(pFolderName+iLength+1) = '\0';	/* null ǥ Է		*/
	}

	return TRUE;
}

BOOL CLocationDlg::BlankInFolderName(char *pFolderName)
{
	int iLength;

	/*  ̸ ̸ ޴´. */
	iLength = strlen(pFolderName);

	/*  ִ ˻Ѵ.  ߰ߵǸ TRUE  */
	for(int i=0; i<iLength; i++)
		if(*(pFolderName+i) == ' ')
			return TRUE;

	return FALSE;
}