#include <windows.h>
#include "CMainDlg.h"
#include "resource.h"

#include "CCommDlg.h"				/* Com Port Setting ȭ Ŭ	*/
#include "CLocationDlg.h"			/*  & ġ  ȭ Ŭ	*/
#include "CAboutDlg.h"				/* α׷  ȭ Ŭ	*/

/****************************************************************************
 **                                                                        **
 **        ##  DSP TMS320F240 O/S Ǵ ñ׳   ##             **
 **                                                                        **
 ****************************************************************************/

#define OS_SIGNAL_DOWNLOAD		0x10		/* α׷ ٿε  ñ׳ */
#define OS_SIGNAL_RUN			0x11		/* α׷  ñ׳          */
#define OS_SIGNAL_STOP			0x12		/* α׷   ñ׳     */
#define OS_SIGNAL_UPLOAD		0x13		/*  ε ñ׳          */
#define OS_SIGNAL_EMPTY			0x00		/* DATA                      */

/****************************************************************************
 **                                                                        **
 **                 ##  CMainDlg /Ҹ   ##                  **
 **                                                                        **
 ****************************************************************************/

CMainDlg::CMainDlg()
{
	/* ø  Ŭ  */
	pSerialComm = new CSerialComm;

	/* Status View List Box Ŭ Ŭ  */
	pStatusView = new CStatusViewListBox;
}

CMainDlg::~CMainDlg()
{
	/* ø  Ŭ ޸𸮿  */
	delete pSerialComm;		pSerialComm = NULL;

	/* Status View List Box Ŭ Ŭ ޸𸮿  */
	delete pStatusView;		pStatusView = NULL;
}

/****************************************************************************
 **                                                                        **
 **                 ##  ȭ ⺻ ޼ ó Լ  ##                 **
 **                                                                        **
 ****************************************************************************/

BOOL CMainDlg::OnInitDialog(HWND hDlg)
{
	/* Base ʱȭ Լ  ȣѴ. */
	CBaseDlg::OnInitDialog(hDlg);

	/* α׷   Ų. */
	HICON hIcon;
	hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_PROGRAM_ICON));
	SetClassLong(hDlg, GCL_HICON, (LONG)hIcon);

	/* Status View List Box θ ȭ ڵ  */
	pStatusView->SetParentDlg(hDlg);

	/* Status View List Box Ʈ ڵ  */
	pStatusView->SetListBox(GetDlgItem(hDlg, IDC_STATUS_VIEW_LIST));

	/* α׷ ʱȭ ŵϴ. */
	InitProgram();

	/* ʱ  ̹ off ·  */
	SetStatusImage(FALSE);

	/* ϰ  ! */
	return TRUE;
}

BOOL CMainDlg::OnCommand(HWND hWndCtl, int wNotifyCode, int wID)
{
	switch(wID)
	{

		/* Source  Open ư óϴ Լ ȣ */
	case IDC_SOURCE_OPEN_BUTTON:
		OnSourceFileOpen();
		return TRUE;

		/* Source  Edit ư óϴ Լ ȣ */
	case IDC_SOURCE_EDIT_BUTTON:
		OnSourceFileEdit();
		return TRUE;

		/* Compile ư óϴ Լ ȣ */
	case IDC_COMPILE_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnCompile())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* Link ư óϴ Լ ȣ */
	case IDC_LINK_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnLink())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* to Hex ư óϴ Լ ȣ */
	case IDC_TOHEX_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnToHex())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* Build ư óϴ Լ ȣ */
	case IDC_BUILD_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnBuild())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* Hex  Open ư óϴ Լ ȣ */
	case IDC_HEX_OPEN_BUTTON:
		OnHexFileOpen();
		return TRUE;

		/* Hex  Edit ư óϴ Լ ȣ */
	case IDC_HEX_EDIT_BUTTON:
		OnHexFileEdit();
		return TRUE;

		/* Download ư óϴ Լ ȣ */
	case IDC_DOWNLOAD_SIGNAL_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnDownloadSignal())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* Run ư óϴ Լ ȣ */
	case IDC_RUN_SIGNAL_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnRunSignal())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* Stop ư óϴ Լ ȣ */
	case IDC_STOP_SIGNAL_BUTTON:
		SetStatusImage(TRUE);	/*  ̹ On Ų. */
		if(OnStopSignal())
			MessageBeep(MB_OK);					/* Ϸ  . */
		else
			MessageBeep(MB_ICONEXCLAMATION);	/*   . */
		SetStatusImage(FALSE);	/*  ̹ Off Ų. */
		return TRUE;

		/* View ASM ư óϴ Լ ȣ */
	case IDC_VIEW_ASM_BUTTON:
		OnViewASM();
		return TRUE;

		/* View LST ư óϴ Լ ȣ */
	case IDC_VIEW_LST_BUTTON:
		OnViewLST();
		return TRUE;

		/* View MAP ư óϴ Լ ȣ */
	case IDC_VIEW_MAP_BUTTON:
		OnViewMAP();
		return TRUE;

		/* Link Command ư óϴ Լ ȣ */
	case IDC_LINK_COMMAND_BUTTON:
		OnLinkCmdSetting();
		return TRUE;

		/* Hex Command ư óϴ Լ ȣ */
	case IDC_HEX_COMMAND_BUTTON:
		OnHexCmdSetting();
		return TRUE;

		/* Location ư óϴ Լ ȣ */
	case IDC_LOCATION_BUTTON:
		OnLocationSetting();
		return TRUE;

		/* Serial Port ư óϴ Լ ȣ */
	case IDC_SERIAL_PORT_BUTTON:
		OnSerialPortSetting();
		return TRUE;

		/* Send Message ư ó ϴ Լ ȣ */
	case IDC_SEND_MESSAGE_BUTTON:
		OnSendMessage();
		return TRUE;

		/* Clear ư óϴ Լ ȣ */
	case IDC_CLEAR_BUTTON:
		OnClear();
		return TRUE;

		/* About ư óϴ Լ ȣ */
	case IDC_ABOUT_BUTTON:
		OnAbout();
		return TRUE;

	}

	/* ׿ ޼ ؼ ȭ ⺻ ޼ */
	/* ó Լ ñ.							 */
	return FALSE;
}

BOOL CMainDlg::OnClose()
{
	/* ø Ʈ µǾ  ݴ´. */
	if(pSerialComm->IsComOpen())
		pSerialComm->CloseComPort();

	/*  FALSE ϸ ȭڰ  ʴ´. */
	return TRUE;
}

/****************************************************************************
 **                                                                        **
 **               ##  Build ׷ ޼ ó Լ   ##                 **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnSourceFileOpen()
{
	char lpstrFile[MAX_PATH] = "";
	char lpstrFileTitle[MAX_PATH] = "";
	OPENFILENAME OFN; /*    ȭ ü */
	BOOL bResult;

	/* ü ʱȭ Ѵ. */
	memset(&OFN, 0, sizeof(OPENFILENAME));

	/* ü μ Է ϱ */
	OFN.lStructSize		= sizeof(OPENFILENAME);		/*  Ȯ		*/
	OFN.hwndOwner		= hDlgMain;					/* θ  ڵ	*/
	OFN.lpstrFilter		= "Source File (*.c;*.asm)\0*.c;*.asm\0"
						  "All Files (*.*)\0*.*\0";	/* 	*/
	OFN.lpstrFile		= lpstrFile;		/*   ̸(+path)    */
	OFN.lpstrFileTitle	= lpstrFileTitle;	/*  ̸  				*/
	OFN.nMaxFile		= MAX_PATH;			/* ִ  							*/
	OFN.lpstrInitialDir = stEnvSet.stPathInfo.szWorkingPath; /* ʱ  			*/

	if(GetOpenFileName(&OFN)) /*  о鿴 */ {
		/*  ̸߿  ִ ˻Ѵ. */
		bResult = BlankInPath(lpstrFile);

		/*  ̸    Ѵ. */
		if(bResult) {
			MessageBox(hDlgMain, " θ߿   ֽϴ.\n\n"
				" Compiler ν  մϴ.\n\n"
				"ٽ  ֽʽÿ.", " Builder", MB_OK | MB_ICONERROR);
			return;
		}

		/*  ڿ õ  θ Է Ѵ. */
		SetDlgItemText(hDlgMain, IDC_SOURCE_PATH_EDIT, lpstrFile);

		/* status view list box о  ǥ ϱ */
		wsprintf(lpstrFile, "%% '%s'   Ǿϴ.", lpstrFileTitle);
		pStatusView->AddString(lpstrFile);
	}
}

void CMainDlg::OnSourceFileEdit()
{
	BOOL bResult;
	UINT iResult;
	char szCommand[MAX_PATH];
	char szSourcePath[MAX_PATH];

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/* Source  ϱ     . */
	wsprintf(szCommand, "%s %s", stEnvSet.stPathInfo.szEditorPath, szSourcePath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

BOOL CMainDlg::OnCompile()
{
	char szSourcePath[MAX_PATH];
	char szRunCommand[MAX_PATH], szResultPath[MAX_PATH];
	BOOL bResult;

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/* Compile  Ǿ ִ  ġ ´. */
	wsprintf(szResultPath, "%scl.dat", stEnvSet.stPathInfo.szToolsPath);

	/* Compile  Ǿ ִ  . */
	DeleteFile(szResultPath);

	/* Compile  . */
	wsprintf(szRunCommand, "%scl240.bat %s",
		stEnvSet.stPathInfo.szToolsPath, szSourcePath);

	/* Compile Ѵٴ ޼ . */
	AddString(IDS_COMPILE_START_STRING);
	AddString(IDS_BLANK_STRING);

	/* Bin  ۾ Ѵ. */
	bResult = RunBinWriteResult(szRunCommand, szResultPath);

	/* Bin  ۾  ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return FALSE;
	}

	/* Compile  ˸. */
	AddString(IDS_BLANK_STRING);
	AddString(IDS_COMPILE_END_STRING);

	return TRUE;
}

BOOL CMainDlg::OnLink()
{
	char szSourcePath[MAX_PATH];
	char szRunCommand[MAX_PATH], szResultPath[MAX_PATH];
	BOOL bResult;

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/* Link  Ǿ ִ  ġ ´. */
	wsprintf(szResultPath, "%slnk.dat", stEnvSet.stPathInfo.szToolsPath);

	/* Link  Ǿ ִ  . */
	DeleteFile(szResultPath);

	/* Source Ͽ Ȯڸ Ѵ. */
	bResult = EraseExtension(szSourcePath);

	/* Ȯڸ ϴ   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/* Link  . */
	wsprintf(szRunCommand, "%slnk240.bat %s",
		stEnvSet.stPathInfo.szToolsPath, szSourcePath);

	/* Link Ѵٴ ޼ . */
	AddString(IDS_LINK_START_STRING);
	AddString(IDS_BLANK_STRING);

	/* Bin  ۾ Ѵ. */
	bResult = RunBinWriteResult(szRunCommand, szResultPath);

	/* Bin  ۾  ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return FALSE;
	}

	/* Link  ˸. */
	AddString(IDS_BLANK_STRING);
	AddString(IDS_LINK_END_STRING);

	return TRUE;
}

BOOL CMainDlg::OnToHex()
{
	char szSourcePath[MAX_PATH];
	char szRunCommand[MAX_PATH], szResultPath[MAX_PATH];
	BOOL bResult;

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/* to Hex  Ǿ ִ  ġ ´. */
	wsprintf(szResultPath, "%shex.dat", stEnvSet.stPathInfo.szToolsPath);

	/* to Hex  Ǿ ִ  . */
	DeleteFile(szResultPath);

	/* Source Ͽ Ȯڸ Ѵ. */
	bResult = EraseExtension(szSourcePath);

	/* Ȯڸ ϴ   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/* to Hex  . */
	wsprintf(szRunCommand, "%shex240.bat %s",
		stEnvSet.stPathInfo.szToolsPath, szSourcePath);

	/* to Hex Ѵٴ ޼ . */
	AddString(IDS_TOHEX_START_STRING);
	AddString(IDS_BLANK_STRING);

	/* Bin  ۾ Ѵ. */
	bResult = RunBinWriteResult(szRunCommand, szResultPath);

	/* Bin  ۾  ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return FALSE;
	}

	/* to Hex  ˸. */
	AddString(IDS_BLANK_STRING);
	AddString(IDS_TOHEX_END_STRING);

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/* Source  Ȯڸ i0 ٲ۴. */
	bResult = ChangeExtension(szSourcePath, "i0");

	/* Ȯڸ ٲٴ   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/*   Hex  Ʈ ڽ Ѵ. */
	SetDlgItemText(hDlgMain, IDC_HEX_PATH_EDIT, szSourcePath);

	return TRUE;
}

BOOL CMainDlg::OnBuild()
{
	if(!OnCompile())	return FALSE;		/* Compile    	*/
	if(!OnLink())		return FALSE;		/* Link    		*/
	if(!OnToHex())		return FALSE;		/* to Hex    		*/

	return TRUE;
}

/****************************************************************************
 **                                                                        **
 **              ##  Signal ׷ ޼ ó Լ   ##                 **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnHexFileOpen()
{
	char lpstrFile[MAX_PATH] = "";
	char lpstrFileTitle[MAX_PATH] = "";
	OPENFILENAME OFN; /*    ȭ ü */

	/* ü ʱȭ Ѵ. */
	memset(&OFN, 0, sizeof(OPENFILENAME));

	/* ü μ Է ϱ */
	OFN.lStructSize		= sizeof(OPENFILENAME);				/*  Ȯ		*/
	OFN.hwndOwner		= hDlgMain;							/* θ  ڵ */
	OFN.lpstrFilter		= "Intel Hex File (*.i0)\0*.i0\0"	/* 				*/
						  "All Files (*.*)\0*.*\0";
	OFN.lpstrFile		= lpstrFile;		/*   ̸(+path)  	*/
	OFN.lpstrFileTitle	= lpstrFileTitle;	/*  ̸  				*/
	OFN.nMaxFile		= MAX_PATH;			/* ִ  							*/
	OFN.lpstrInitialDir = stEnvSet.stPathInfo.szWorkingPath; /* ʱ  			*/

	if(GetOpenFileName(&OFN)) /*  о鿴 */ {
		/*  ڿ о  θ ԷѴ. */
		SetDlgItemText(hDlgMain, IDC_HEX_PATH_EDIT, lpstrFile);

		/* status view list box о  ǥ ϱ */
		wsprintf(lpstrFile, "%% '%s'   Ǿϴ.", lpstrFileTitle);
		pStatusView->AddString(lpstrFile);
	}
}

void CMainDlg::OnHexFileEdit()
{
	BOOL bResult;
	UINT iResult;
	char szCommand[MAX_PATH];
	char szHexPath[MAX_PATH];

	/*  ڷ  Hex  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_HEX_PATH_EDIT,		/*   ID		*/
							 szHexPath,				/* ڿ   */
							 sizeof(szHexPath));	/*  ũ			*/

	/* Hex  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/* Hex  ϱ     . */
	wsprintf(szCommand, "%s %s", stEnvSet.stPathInfo.szEditorPath, szHexPath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

BOOL CMainDlg::OnDownloadSignal()
{
	HANDLE hFile;
	BOOL bResult;
	BYTE btGetByte;
	BYTE pCommand[100];
	char lpstrFile[MAX_PATH];

	/*  ڽκ  ̸  ´. */
	bResult = GetDlgItemText(hDlgMain, IDC_HEX_PATH_EDIT, lpstrFile, MAX_PATH);

	/*  ڽ  ̸   ʴٸ  Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return FALSE;
	}

	/*  ڵ  ´. */
	hFile = CreateFile(lpstrFile, 
					   GENERIC_READ,
					   0, 
					   NULL, 
					   OPEN_EXISTING, 
					   FILE_ATTRIBUTE_NORMAL, NULL);

	/*  ڵ  ü ٸ  Ѵ. */
	if(hFile == INVALID_HANDLE_VALUE) {
		AddString(IDS_FILE_OPEN_ERROR_STRING);
		return FALSE;
	}

	/* Download ȣ 忡  ͸  غ Ų. */
	btGetByte = (BYTE)OS_SIGNAL_DOWNLOAD;
	bResult = pSerialComm->SendData((LPSTR)&btGetByte, sizeof(BYTE));

	/* Download ȣ    ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_DOWNLOAD_ERROR_STRING);
		return FALSE;
	}

	while(1) {

		/* ʵ  ǥø Ѵ. */
		bResult = GetFieldStartChar(hFile); 

		/* ʵ  ǥø ߰ ߰ų  */
		/* д   ߻ϸ             */
		if(!bResult) {
			AddString(IDS_HEX_FORMAT_ERROR_STRING);
			break;
		}

		/*  ̸ о ´. */
		bResult = GetByte(hFile, btGetByte);

		/*  Ʈ о ߿  ߻ߴٸ  */
		if(!bResult) {
			AddString(IDS_HEX_FORMAT_ERROR_STRING);
			break;
		}

		/* Command 迭 Data  ǥ */
		pCommand[0] = btGetByte;

		/* Address  Ʈ о ´. */
		bResult = GetByte(hFile, btGetByte);

		/*  Ʈ о ߿  ߻ߴٸ  */
		if(!bResult) {
			AddString(IDS_HEX_FORMAT_ERROR_STRING);
			break;
		}

		/* Address  Ʈ  */
		pCommand[1] = btGetByte;

		/* Address  Ʈ о ´. */
		bResult = GetByte(hFile, btGetByte);

		/*  Ʈ о ߿  ߻ߴٸ  */
		if(!bResult) {
			AddString(IDS_HEX_FORMAT_ERROR_STRING);
			break;
		}
		
		/* Address  Ʈ  */
		pCommand[2] = btGetByte;

		/* ڵ  о´. */
		bResult = GetByte(hFile, btGetByte);

		/*  Ʈ о ߿  ߻ߴٸ  */
		if(!bResult) {
			AddString(IDS_HEX_FORMAT_ERROR_STRING);
			break;
		}

		/* ڵ  ڵ  Ÿ Download  */
		if(btGetByte == 0x01) {

			/* Download  ϷǾٴ ȣ 忡 . */
			btGetByte = (BYTE)OS_SIGNAL_EMPTY;
			bResult = pSerialComm->SendData((LPSTR)&btGetByte, sizeof(BYTE));

			/* 忡 ȣ    ߻ϸ   */
			if(!bResult) {
				AddString(IDS_DOWNLOAD_ERROR_STRING);
				break;
			}
			
			/* Download ϷǾٴ ޼ ǥѴ. */
			AddString(IDS_DOWNLOAD_SUCCESS_STRING);

			break;
		}

		/* ͸ о ´. */
		for(BYTE i=0; i<pCommand[0]; i++) {

			/*   Ʈ о´. */
			bResult = GetByte(hFile, btGetByte);

			/* ͸ дµ  ߻ϸ  */
			if(!bResult) {
				/*  ޼  */
				AddString(IDS_HEX_FORMAT_ERROR_STRING);

				/*  ڵ  ش. */
				CloseHandle(hFile);

				return FALSE;
			}

			/* Command о   */
			pCommand[3+i] = btGetByte;
		}

		/*  ͸ . */
		bResult = pSerialComm->SendData((LPSTR)pCommand, (DWORD)(pCommand[0]+3));

		/* ͸    ߻ϸ   */
		if(!bResult) {
			AddString(IDS_DOWNLOAD_ERROR_STRING);
			return FALSE;
		}
	}

	/*  ڵ  ش. */
	CloseHandle(hFile);

	return TRUE;
}

BOOL CMainDlg::OnRunSignal()
{
	BOOL bResult;
	BYTE sig = OS_SIGNAL_RUN;

	/* 忡 Run ȣ . */
	bResult = pSerialComm->SendData((LPSTR)&sig, sizeof(BYTE));

	/* ȣ    ߻ϸ  */
	if(!bResult) {
		AddString(IDS_RUN_ERROR_STRING);
		return FALSE;
	}

	/* Run ȣ  ´ٴ ޼ ǥ */
	AddString(IDS_RUN_SUCCESS_STRING);

	return TRUE;
}

BOOL CMainDlg::OnStopSignal()
{
	BOOL bResult;

	/* 带 Reset Ų. */
	bResult = pSerialComm->SetDTR();

	/* Reset   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_STOP_ERROR_STRING);
		return FALSE;
	}

	/* 带 Signal  ȯѴ. */
	bResult = pSerialComm->ClearDTR();

	/* Signal  ȯ   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_SIGNAL_MODE_ERROR_STRING);
		return FALSE;
	}

	/* Stop ȣ  ´ٴ ޼ ǥ */
	AddString(IDS_STOP_SUCCESS_STRING);

	return TRUE;
}

/****************************************************************************
 **                                                                        **
 **          ##  Build Result View ׷ ޼ ó Լ  ##           **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnViewASM()
{
	BOOL bResult;
	UINT iResult;
	char szCommand[MAX_PATH];
	char szSourcePath[MAX_PATH];

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/* Source  Ȯڸ asm ٲ۴. */
	bResult = ChangeExtension(szSourcePath, "asm");

	/* Ȯڸ ٲٴ   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/*  ġ ҽ ġ Ͽ ɶ . */
	wsprintf(szCommand, "%s %s", stEnvSet.stPathInfo.szEditorPath, szSourcePath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

void CMainDlg::OnViewLST()
{
	BOOL bResult;
	UINT iResult;
	char szCommand[MAX_PATH];
	char szSourcePath[MAX_PATH];

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/* Source  Ȯڸ lst ٲ۴. */
	bResult = ChangeExtension(szSourcePath, "lst");

	/* Ȯڸ ٲٴ   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/*  ġ ҽ ġ Ͽ ɶ . */
	wsprintf(szCommand, "%s %s", stEnvSet.stPathInfo.szEditorPath, szSourcePath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

void CMainDlg::OnViewMAP()
{
	BOOL bResult;
	UINT iResult;
	char szCommand[MAX_PATH];
	char szSourcePath[MAX_PATH];

	/*  ڷ  Source  ġ о ´. */
	bResult = GetDlgItemText(hDlgMain,				/* θ ȭ ڵ	*/
							 IDC_SOURCE_PATH_EDIT,	/*   ID		*/
							 szSourcePath,			/* ڿ   */
							 sizeof(szSourcePath));	/*  ũ			*/

	/* Source  ġ о   ߻ϸ Ѵ. */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/* Source  Ȯڸ map ٲ۴. */
	bResult = ChangeExtension(szSourcePath, "map");

	/* Ȯڸ ٲٴ   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_NULL_FILE_ERROR_STRING);
		return;
	}

	/*  ġ ҽ ġ Ͽ ɶ . */
	wsprintf(szCommand, "%s %s", stEnvSet.stPathInfo.szEditorPath, szSourcePath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

/****************************************************************************
 **                                                                        **
 **        ##  Build Command Setting ׷ ޼ ó Լ  ##         **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnLinkCmdSetting()
{
	UINT iResult;
	char szCommand[MAX_PATH];

	/*   . */
	wsprintf(szCommand, "%s %slnk2xx.cmd",
		stEnvSet.stPathInfo.szEditorPath, stEnvSet.stPathInfo.szToolsPath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

void CMainDlg::OnHexCmdSetting()
{
	UINT iResult;
	char szCommand[MAX_PATH];

	/*   . */
	wsprintf(szCommand, "%s %shex2xx.cmd",
		stEnvSet.stPathInfo.szEditorPath, stEnvSet.stPathInfo.szToolsPath);

	/* ⸦  Ų. */
	iResult = WinExec(szCommand, SW_SHOWNORMAL);

	/* ⸦  ϴ   ߻Ͽٸ Ѵ. */
	if(iResult <= 31) { /*   ϰ 31 ۰ų . */
		AddString(IDS_CANT_FIND_PROGRAM_STRING);
		return;
	}
}

/****************************************************************************
 **                                                                        **
 **          ##  Environment Setting ׷ ޼ ó Լ  ##         **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnLocationSetting()
{
	int iResult;
	BOOL bResult;

	/*  & ġ  ȭ Ŭ ޸𸮿 ҴѴ. */
	CLocationDlg *pLocationDlg = new CLocationDlg;

	/* ȭڿ  &   ü Ѵ. */
	pLocationDlg->SetLocationInfo(stEnvSet.stPathInfo);

	/* ȭڸ ȭ鿡 ǥѴ. */
	iResult = pLocationDlg->ShowDialogBox(hInstance, hDlgMain, IDD_LOCATION_DIALOG);

	/* Ȯ ư   */
	if(iResult == IDOK) {
		/*    &   ü ´. */
		pLocationDlg->GetLocationInfo(stEnvSet.stPathInfo);

		/* ο ȯ  ͸ ߴٴ ޼  */
		AddString(IDS_ENVSET_UPDATE_SUCCESS_STRING);

		/* ȯ  ͸ Ͽ Ѵ. */
		bResult = WriteEnvSet();

		/* Ͽ ϴ   ߻   ޼  */
		if(!bResult)
			AddString(IDS_ENVSET_WRITE_ERROR_STRING);
	}

	/* Ҵ ޸𸮸 Ѵ. */
	delete pLocationDlg;	pLocationDlg = NULL;
}
		
void CMainDlg::OnSerialPortSetting()
{
	int iResult;
	BOOL bResult;

	/* ø Ʈ  ȭ Ŭ ޸𸮿 ҴѴ. */
	CCommDlg *pCommDlg = new CCommDlg;

	/* ȭڿ  &   ü Ѵ. */
	pCommDlg->SetCommInfo(stEnvSet.stCommInfo);

	/* ȭڸ ȭ鿡 ǥѴ. */
	iResult = pCommDlg->ShowDialogBox(hInstance, hDlgMain, IDD_COMM_DIALOG);

	/* Ȯ ư   */
	if(iResult == IDOK) {
		/*   ø Ʈ  ü ´. */
		pCommDlg->GetCommInfo(stEnvSet.stCommInfo);

		/* ο ȯ  ͸ ߴٴ ޼  */
		AddString(IDS_ENVSET_UPDATE_SUCCESS_STRING);

		/* ȯ  ͸ Ͽ Ѵ. */
		bResult = WriteEnvSet();

		/* Ͽ ϴ   ߻   ޼  */
		if(!bResult)
			AddString(IDS_ENVSET_WRITE_ERROR_STRING);

		/*  ø Ʈ  Ǿ ִ ȮѴ. */
		bResult = pSerialComm->IsComOpen();

		/* ø Ʈ µǾ  */
		if(bResult) {
			/* ø Ʈ ݴ´ٴ ޼ . */
			AddString(IDS_COMM_CLOSE_SUCCESS_STRING);

			/*   ִ ø Ʈ ݴ´. */
			pSerialComm->CloseComPort();
		}

		/* ø Ʈ ʱȭ Ѵ. */
		InitSerialPort();
	}
	
	/* Ҵ ޸𸮸 Ѵ. */
	delete pCommDlg;	pCommDlg = NULL;
}

/****************************************************************************
 **                                                                        **
 **                     ##  About ȭ  Լ  ##                   **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnAbout()
{
	int iResult;

	/* α׷  ȭ Ŭ ޸𸮿 ҴѴ. */
	CAboutDlg *pAboutDlg = new CAboutDlg;

	/* α׷  ȭڸ ȭ鿡 ǥѴ. */
	iResult = pAboutDlg->ShowDialogBox(hInstance, hDlgMain, IDD_ABOUT_DIALOG);

	/* Ҵ ޸𸮸 Ѵ. */
	delete pAboutDlg;		pAboutDlg = NULL;
}

/****************************************************************************
 **                                                                        **
 **                 ##  Status View List Box  Լ  ##                 **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::OnSendMessage()
{
	char szGetString[100];
	BYTE btDone, btByte;
	BOOL bResult;
	int length;

	/*  ڷκ ͸ Է ޴´. */
	GetDlgItemText(hDlgMain, IDC_SEND_MESSAGE_EDIT, szGetString, sizeof(szGetString));
	length = strlen(szGetString);

	/*  ̰ ¦ ƴϸ   */
	if(length%2) {
		AddString(IDS_SEND_MESSAGE_ERROR_STRING);
		return;
	}

	for(int i=0; i<length; i+=2)
	{
		btByte = szGetString[i+0];
		ConvertHexToNibble(btByte);
		btDone = (btByte<<4);

		btByte = szGetString[i+1];
		ConvertHexToNibble(btByte);
		btDone |= btByte;

		bResult = pSerialComm->SendData((LPSTR)&btDone, 1);
		if(!bResult) {
			AddString(IDS_SEND_MESSAGE_ERROR_STRING);
			return;
		}
	}

	/* Ϸ ޼ . */
	AddString(IDS_SEND_MESSAGE_COMPLETE_STRING);
}

void CMainDlg::OnClear()
{
	pStatusView->DeleteAll();
}

/****************************************************************************
 **                                                                        **
 **                        ##  Ŭ Լ   ##                    **
 **                                                                        **
 ****************************************************************************/

void CMainDlg::DefaultEnvSetting()
{
	/* øƮ   ִ ü ʱȭ */
	stEnvSet.stCommInfo.Port	 = 1;		/* ø Ʈ ȣ (1)	*/
	stEnvSet.stCommInfo.BaudRate = 19200;	/*  ӵ (19200)	*/
	stEnvSet.stCommInfo.ByteSize = 8;		/* Ʈ  (8)		*/
	stEnvSet.stCommInfo.StopBits = 1;		/* Stop Bit  (1)	*/
	stEnvSet.stCommInfo.Parity   = 0;		/* иƼ / ()	*/

	/*  ġ ʱȭ Ѵ. */
	strcpy(stEnvSet.stPathInfo.szEditorPath, "notepad.exe");

	/* Build  ġ  ִ ġ ʱȭ Ѵ. */
	strcpy(stEnvSet.stPathInfo.szToolsPath, "c:\\eslab240\\tools\\");

	/* ۾  ʱȭ Ѵ. */
	strcpy(stEnvSet.stPathInfo.szWorkingPath, "c:\\eslab240\\user\\");
}

BOOL CMainDlg::InitProgram()
{
	BOOL bResult;

	/* α׷   Ѵ. */
	AddString(IDS_PROGRAM_INFO1_STRING);
	AddString(IDS_PROGRAM_INFO2_STRING);
	AddString(IDS_BLANK_STRING);

	/* Ͽ ȯ漳 ͸ о ´. */
	bResult = ReadEnvSet();

	/* ȯ  ͸ о    ߻ϸ	*/
	/* default ͸ ʱȭ ϰ default   */
	/* Ͽ Ѵ.										*/
	if(!bResult) {
		/* Ϸκ ȯ漳 ͸ оü ٴ  ޼  */
		AddString(IDS_ENVSET_READ_ERROR_STRING);

		/* Default ȯ漳 ͸ Ѵ. */
		DefaultEnvSetting();

		/* Default ȯ漳 ͸ Ѵٴ ޼ Ѵ. */
		AddString(IDS_ENVSET_DEFAULT_STRING);
		
		/* Ͽ Default ȯ漳 ͸ Ѵ. */
		bResult = WriteEnvSet();

		/* ͸ ϴ   ߻ϸ  ޼  */
		if(!bResult)
			AddString(IDS_ENVSET_WRITE_ERROR_STRING);

		/* ó  쿡 α׷  ȭڸ Ѵ. */
		OnAbout();
	}

	/* ø Ʈ ʱȭ Ѵ. */
	InitSerialPort();

	return TRUE;
}

BOOL CMainDlg::InitSerialPort()
{
	BOOL bResult;

	/* øƮ Ŭ  ش. */
	pSerialComm->SetComPort(stEnvSet.stCommInfo);

	/* øƮ Ѵ. */
	bResult = pSerialComm->OpenComPort();

	/* øƮ    ޼ Ѵ. */
	if(! bResult) {
		AddString(IDS_COMM_OPEN_ERROR_STRING);		/* Ͽ */
		return FALSE;
	} else
		AddString(IDS_COMM_OPEN_SUCCESS_STRING);	/* Ͽ */		

	/* 带 Signal  ȯմϴ. */
	bResult = pSerialComm->ClearDTR();

	/* 带 Signal  ȯϴ   ߻ϸ  */
	if(!bResult) {
		AddString(IDS_SIGNAL_MODE_ERROR_STRING);
		return FALSE;
	}

	return TRUE;
}

BOOL CMainDlg::AddString(UINT nID)
{
	BOOL bResult;

	/* ڿ ̺ ڿ о ۿ Ѵ. */
	bResult = LoadString(hInstance, nID, szGetString, sizeof(szGetString));

	/* ڿ ̺ ڿ д  ߻ϸ   */
	if(!bResult) return FALSE;

	/* Status View List Box ڿ ߰Ѵ. */
	bResult = pStatusView->AddString(szGetString);

	/* ڿ ߰ϴ   ߻ϸ   */
	if(!bResult) return FALSE;

	return TRUE;
}

BOOL CMainDlg::GetFieldStartChar(HANDLE hFile)
{
	DWORD dwRead;
	BYTE btByte;
	BOOL bResult;

	do {
		/* Ϸ   ڸ о δ. */
		bResult = ReadFile(hFile, &btByte, sizeof(btByte), &dwRead, NULL);

		/* ѹ б⿡ ߴٸ   */
		if(!bResult) return FALSE;

	} while(btByte != ':');

	return TRUE;
}

BOOL CMainDlg::GetByte(HANDLE hFile, BYTE &btDone)
{
	DWORD dwRead;
	BYTE btRead;
	BOOL bResult;

	/*   */
	btDone = 0x00;

	/* Ϸ   ڸ о δ. */
	bResult = ReadFile(hFile, &btRead, sizeof(btRead), &dwRead, NULL);

	/* ѹ б⿡ ߴٸ   */
	if(!bResult) return FALSE;

	/* ѹڸ Nibble  ȯѴ. */
	bResult = ConvertHexToNibble(btRead);

	/* Nibble  ȯ ߴٸ   */
	if(!bResult) return FALSE;

	/*  Nibble  */
	btDone |= (btRead << 4);

	/* Ϸ   ڸ о δ. */
	bResult = ReadFile(hFile, &btRead, sizeof(btRead), &dwRead, NULL);

	/* ѹ б⿡ ߴٸ   */
	if(!bResult) return FALSE;

	/* ѹڸ Nibble  ȯѴ. */
	bResult = ConvertHexToNibble(btRead);

	/* Nibble  ȯ ߴٸ   */
	if(!bResult) return FALSE;

	/*  Nibble  */
	btDone |= btRead;

	return TRUE;
}

BOOL CMainDlg::ConvertHexToNibble(BYTE &btHexToNibble)
{
	if(btHexToNibble >= '0' && btHexToNibble <= '9')
		btHexToNibble = ((btHexToNibble - '0') & 0x0f);

	else if(btHexToNibble >= 'a' && btHexToNibble <= 'f')
		btHexToNibble = ((btHexToNibble - 'a' + 10) & 0x0f);

	else if(btHexToNibble >= 'A' && btHexToNibble <= 'F')
		btHexToNibble = ((btHexToNibble - 'A' + 10) & 0x0f);

	else
		return FALSE;

	return TRUE;
}

BOOL CMainDlg::Delay(int iMicroSecs)
{
	LARGE_INTEGER st, ed, freq;
	double dDelay;
	BOOL bResult;

	/* 1ʵ ļ Ѵ. */
	bResult = QueryPerformanceFrequency(&freq);

	/* ý ػ Ÿ̸Ӹ    */
	if(!bResult)
		return FALSE;

	/* Delay  ð ϱ */
	dDelay = double(double(iMicroSecs) * double(freq.QuadPart/1000000.0f));

	QueryPerformanceCounter(&st);

	do {
		QueryPerformanceCounter(&ed);
	} while(double(ed.QuadPart) <= (double(st.QuadPart) + dDelay));

	return TRUE;
}

/*  Լ C Source Assembly Source Ͽ Compile ϱ */
/*  .    ʴ´.						*/
BOOL CMainDlg::GetFirstCharInExt(char *pFileName, char &cGet)
{
	/* Ķ μ null ̸  */
	if(pFileName == NULL)
		return FALSE;

	char *ploc;

	/*  ̸ Ȯڸ   '.' ãƳ ͸ Ѵ. */
	ploc = strrchr(pFileName, '.');

	/* '.' ã ϰų  ߻ϸ Ѵ. */
	if(ploc == NULL)
		return FALSE;

	/*  Ȯ ù ڸ Ѵ. */
	cGet = *(ploc+1);

	return TRUE;
}

BOOL CMainDlg::ChangeExtension(char *pFileName, char *pNewExt)
{
	/* Ķ μ null ̸  */
	if(pFileName == NULL || pNewExt == NULL)
		return FALSE;
	
	char *ploc;

	/*  ̸ Ȯڸ   '.' ãƳ ͸ Ѵ. */
	ploc = strrchr(pFileName, '.');

	/* '.' ã ϰų  ߻ϸ Ѵ. */
	if(ploc == NULL)
		return FALSE;

	/* '.' ġ Ű ͸ Ȯ ó ۺκ Ű Ѵ. */
	ploc++;

	/* 'map'̶ ο Ȯڸ οѴ. */
	strcpy(ploc, pNewExt);

	return TRUE;
}

BOOL CMainDlg::EraseExtension(char *pFileName)
{
	/* Ķ μ null ̸  */
	if(pFileName == NULL)
		return FALSE;

	char *ploc;

	/*  ̸ Ȯڸ   '.' ãƳ ͸ Ѵ. */
	ploc = strrchr(pFileName, '.');

	/* '.' ã ϰų  ߻ϸ Ѵ. */
	if(ploc == NULL)
		return FALSE;

	/* '.' ġ null Ͽ Ȯڸ Ѵ. */
	*ploc = '\0';

	return TRUE;
}

BOOL CMainDlg::RunBinWriteResult(char *pRunCommand, char *pResultPath)
{
	/* μ null̸   Ѵ. */
	if(pRunCommand == NULL || pResultPath == NULL)
		return FALSE;

	/*  д ۿ   */
	HANDLE hFile;
	DWORD dwRead;
	int pos = 0;
	char szBuffer[100], ch;

	/* ׿  */
	BOOL bResult;

	/* α׷  Ų. */
	WinExec(pRunCommand, SW_HIDE);

	do {
		/* Bin α׷  Ǿ ִ  Ǿ ִ ȮѴ. */
		hFile = CreateFile(pResultPath,		/* pointer to name of the file				*/
					GENERIC_READ,			/* access (read-write) mode					*/
					0,						/* share mode								*/
					NULL,					/* pointer to security attributes			*/
					OPEN_EXISTING,			/* how to create							*/
					FILE_ATTRIBUTE_NORMAL,  /* file attributes							*/
					NULL);					/* handle to file with attributes to copy	*/

	} while(hFile == INVALID_HANDLE_VALUE); /* ȿ  ڵ   */

	/*   Status View List Box ǥϴ ƾ */
	while(1) {

		/* Bin α׷   ִ Ϸκ  ڸ оδ. */
		bResult = ReadFile(hFile, &ch, sizeof(ch), &dwRead, NULL);

		/*  ڸ д   ߰ߵǸ  ƾ ŻѴ. */
		if(!bResult || dwRead == 0)
			break;

		/* ๮ '\r' ν ʵ Ѵ. */
		if(ch == '\r')
			continue;

		/* ๮ '\n' νĵǸ  ۿ ϵ ڿ	*/
		/* Status View List Box ߰Ѵ.								*/
		else if(ch == '\n') {
			/*   null ڸ ߰Ͽ   Ÿ. */
			szBuffer[pos++] = '\0';

			/* Status View List Box ڿ ߰Ѵ. */
			pStatusView->AddString(szBuffer);

			/*   ġ ʱȭ Ѵ. */
			pos = 0;
		}
		
		/* ׿ ڴ ۿ Ѵ. */
		else
			szBuffer[pos++] = ch;
	}

	/* Status View List Box  ϴ    ڵ ݴ´. */
	CloseHandle(hFile);

	return TRUE;
}

BOOL CMainDlg::ReadEnvSet()
{
	HANDLE hFile;
	DWORD dwRead;
	BOOL bResult;

	/*  Ѵ. */
	hFile = CreateFile("c:\\setup240.dat",
					   GENERIC_READ,
					   0,
					   NULL,
					   OPEN_EXISTING,
					   FILE_ATTRIBUTE_NORMAL,
					   NULL);

	/*  д   ߻ϸ  */
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;

	/* ȯ  ͸ о ´. */
	bResult = ReadFile(hFile, &stEnvSet, sizeof(stEnvSet), &dwRead, NULL);

	/* ͸ о   ߻ϸ  */
	if(!bResult || dwRead == 0)
		return FALSE;

	/*  ڵ ݴ´. */
	CloseHandle(hFile);

	return TRUE;
}

BOOL CMainDlg::WriteEnvSet()
{
	HANDLE hFile;
	DWORD dwWritten;
	BOOL bResult;

	/*  Ѵ. */
	hFile = CreateFile("c:\\setup240.dat",
					   GENERIC_WRITE,
					   0,
					   NULL,
					   OPEN_ALWAYS,
					   FILE_ATTRIBUTE_NORMAL,
					   NULL);

	/*  д   ߻ϸ  */
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;

	/* ȯ  ͸ о ´. */
	bResult = WriteFile(hFile, &stEnvSet, sizeof(stEnvSet), &dwWritten, NULL);

	/* ͸ о   ߻ϸ  */
	if(!bResult || dwWritten == 0)
		return FALSE;

	/*  ڵ ݴ´. */
	CloseHandle(hFile);

	return TRUE;
}

BOOL CMainDlg::BlankInPath(char *pPath)
{
	int iLength;

	/*  θ ̸ ޴´. */
	iLength = strlen(pPath);

	/*  ִ ˻Ѵ.  ߰ߵǸ TRUE  */
	for(int i=0; i<iLength; i++)
		if(*(pPath+i) == ' ')
			return TRUE;

	return FALSE;
}

void CMainDlg::SetStatusImage(BOOL IsOn)
{
	HWND hBitmapStatic;
	HBITMAP hStatusBitmap;

	/*  ̹ Ʈ ڵ Ѵ. */
	hBitmapStatic = GetDlgItem(hDlgMain, IDC_STATUS_IMAGE_STATIC);

	/* ĶͿ  ٸ ̹ Ѵ. */
	if(IsOn)
		hStatusBitmap = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_LIGHT_ON_BITMAP));
	else 
		hStatusBitmap = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_LIGHT_OFF_BITMAP));

	/* ̹  ̹ Ʈѿ ǥѴ. */
	SendMessage(hBitmapStatic,
				STM_SETIMAGE,
				(WPARAM)IMAGE_BITMAP,
				(LPARAM)hStatusBitmap);

	/* Ʈѿ  ׸⸦ õѴ. */
	UpdateWindow(hBitmapStatic);
}