#include <windows.h>
#include "CSerialComm.h"
#include <stdio.h>

/****************************************************************************
 **                                                                        **
 **                ##  CSerialComm /Ҹ   ##                **
 **                                                                        **
 ****************************************************************************/

CSerialComm::CSerialComm()
{
	/* Com Ʈ    ִ  ʱȭ Ų. */
	bAlreadyComOpen = FALSE;
}

CSerialComm::~CSerialComm()
{

}

/****************************************************************************
 **                                                                        **
 **                    ##  ܺο Ǵ Լ   ##                   **
 **                                                                        **
 ****************************************************************************/

/* Port : Serial Port Number ( 1 - 4 )                                  *
 * Rate :   110,   600,  1200,  2400,   4800,   9600,  14400,           *
 *        19200, 38400, 56000, 57600, 115200, 128000, 256000            *
 * ByteSize :  Number of bits/byte ( 4 - 8 )                            *
 * Stop : Stop bits ( 0 = 1, 1 = 1.5, 2 = 2 )                           *   <- ߿
 * Parity : Parity bit ( 0 = no, 1=odd, 2= even, 3 = mark, 4 = space )  */
void CSerialComm::SetComPort(_CommInfo &stInfo)
{
	/*  øƮ  Ų. */
	memcpy((void *)&stCommInfo, (void *)&stInfo, sizeof(_CommInfo));

	/* Stop bit  ġ ġ 1 ̰ Ƿ	*/
	/* ġ 1 .										*/
	stCommInfo.StopBits--;

	/* TMS320F240 Stop Ʈ  1.5  .	*/
	/* ׷Ƿ 1.5 õ  2 Ѵ.				*/
	if(stCommInfo.StopBits == 1)
		stCommInfo.StopBits = 2;
}

BOOL CSerialComm::OpenComPort()
{
	DCB dcb;
	BOOL bResult;
	char szPortNum[20];

	wsprintf(szPortNum, "COM%d", stCommInfo.Port);

	hCom = CreateFile( szPortNum,
		GENERIC_WRITE,
		0,				/* comm devices must be opened w/exclusive-access	*/
		NULL,			/* no security attributes							*/
		OPEN_EXISTING,	/* comm devices must use OPEN_EXISTING				*/
		0,				/* not overlapped I/O								*/
		NULL);			/* hTemplate must be NULL for comm devices			*/
	
	if (hCom == INVALID_HANDLE_VALUE)
		return FALSE;

	/* Setting Rx Buffer, Tx Buffer */
	SetupComm(hCom, 4096, 4096);

	/* Abort all, and clean the buffer */
	PurgeComm(hCom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR) ;

	/* Identify version */
	dcb.DCBlength	= sizeof(DCB);

	/* Omit the call to SetupComm to use the default queue sizes.	*/
	/* Get the current configuration.								*/
	bResult = GetCommState(hCom, &dcb);

	if (!bResult)
		return FALSE;

	/* Fill in the DCB */
	dcb.BaudRate	= stCommInfo.BaudRate;
	dcb.ByteSize	= stCommInfo.ByteSize;
	dcb.Parity		= stCommInfo.Parity;
	dcb.StopBits	= stCommInfo.StopBits;

	/* Set the new configuration. */
	bResult = SetCommState(hCom, &dcb);

	if (!bResult) return FALSE;

	/* Update Serial Port Open Infomation */
	bAlreadyComOpen = TRUE;

	return TRUE;
}

BOOL CSerialComm::IsComOpen()
{
	return bAlreadyComOpen;
}

BOOL CSerialComm::ClearDTR()
{
	BOOL bResult;

	/* Clear data terminal ready signal */
	bResult = EscapeCommFunction(hCom, CLRDTR);

	if(!bResult) return FALSE;

	return TRUE;
}

BOOL CSerialComm::SetDTR()
{
	BOOL bResult;

	/* Set data terminal ready signal */
	bResult = EscapeCommFunction(hCom, SETDTR);

	if(!bResult) return FALSE;

	return TRUE;	
}

BOOL CSerialComm::SendData(LPSTR lpByte,   /*    Ʈ */
						   DWORD dwLength) /*   */
{
	BOOL		bResult;
	DWORD		dwWrittenLength;	/*    ̰ ȴ. */

	bResult = WriteFile(hCom, lpByte, dwLength, &dwWrittenLength, NULL);
	
	if(!bResult)
		return FALSE;

	return TRUE;
}

BOOL CSerialComm::CloseComPort()
{
	/* Abort all, and clean the buffer */
	PurgeComm(hCom, PURGE_TXABORT | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_RXCLEAR);

	/* Close com port */
	CloseHandle(hCom);

	/* Update Serial Port Open Infomation */
	bAlreadyComOpen = FALSE;

	return TRUE;
}